package cn.com.infosec.asn1.x509;

import cn.com.infosec.asn1.ASN1Encodable;
import cn.com.infosec.asn1.ASN1EncodableVector;
import cn.com.infosec.asn1.ASN1Sequence;
import cn.com.infosec.asn1.DERInteger;
import cn.com.infosec.asn1.DERObject;
import cn.com.infosec.asn1.DERSequence;
import java.util.Enumeration;
import java.util.Vector;

public class NoticeReference extends ASN1Encodable {
   private DisplayText organization;
   private ASN1Sequence noticeNumbers;

   public NoticeReference(String orgName, Vector numbers) {
      this.organization = new DisplayText(orgName);
      Object var10000 = numbers.elementAt(0);
      ASN1EncodableVector orgName1;
      orgName1 = new ASN1EncodableVector.<init>();
      if (var10000 instanceof Integer) {
         Enumeration numbers1 = numbers.elements();

         while(numbers1.hasMoreElements()) {
            Integer var3 = (Integer)numbers1.nextElement();
            orgName1.add(new DERInteger(var3));
         }
      }

      NoticeReference var4 = this;
      DERSequence var5;
      var5 = new DERSequence.<init>(orgName1);
      var4.noticeNumbers = var5;
   }

   public NoticeReference(String orgName, ASN1Sequence numbers) {
      NoticeReference var10000 = this;
      NoticeReference var10001 = this;
      super();
      DisplayText var3;
      var3 = new DisplayText.<init>(orgName);
      var10001.organization = var3;
      var10000.noticeNumbers = numbers;
   }

   public NoticeReference(int displayTextType, String orgName, ASN1Sequence numbers) {
      NoticeReference var10000 = this;
      NoticeReference var10001 = this;
      super();
      DisplayText var4;
      var4 = new DisplayText.<init>(displayTextType, orgName);
      var10001.organization = var4;
      var10000.noticeNumbers = numbers;
   }

   public NoticeReference(ASN1Sequence as) {
      if (as.size() == 2) {
         this.organization = DisplayText.getInstance(as.getObjectAt(0));
         this.noticeNumbers = ASN1Sequence.getInstance(as.getObjectAt(1));
      } else {
         throw new IllegalArgumentException("Bad sequence size: " + as.size());
      }
   }

   public static NoticeReference getInstance(Object as) {
      if (as instanceof NoticeReference) {
         return (NoticeReference)as;
      } else if (as instanceof ASN1Sequence) {
         return new NoticeReference((ASN1Sequence)as);
      } else {
         throw new IllegalArgumentException("unknown object in getInstance.");
      }
   }

   public DisplayText getOrganization() {
      return this.organization;
   }

   public ASN1Sequence getNoticeNumbers() {
      return this.noticeNumbers;
   }

   public DERObject toASN1Object() {
      ASN1EncodableVector var1;
      ASN1EncodableVector var10000 = var1 = new ASN1EncodableVector;
      var1.<init>();
      var1.add(this.organization);
      var10000.add(this.noticeNumbers);
      return new DERSequence(var1);
   }
}
